Package jcifs

# Class Config

java.lang.Object
jcifs.Config

public class Config extends Object
This class uses a static `Properties` to act as a cental repository for all jCIFS configuration properties. It cannot be instantiated. Similar to `System` properties the namespace is global therefore property names should be unique. Before use, the `load` method should be called with the name of a `Properties` file (or `null` indicating no file) to initialize the `Config`. The `System` properties will then populate the `Config` as well potentially overwriting properties from the file. Thus properties provided on the commandline with the `-Dproperty.name=value` VM parameter will override properties from the configuration file.

There are several ways to set jCIFS properties. See the overview page of the API documentation for details.

## Field Summary

Fields
Modifier and Type
Field
Description
`static String`
`DEFAULT_OEM_ENCODING`
`static int`
`socketCount`

## Method Summary

Modifier and Type
Method
Description
`static Object`
`get(String key)`
Retrieve a property as an `Object`.
`static boolean`
`getBoolean(String key, boolean def)`
Retrieve a boolean value.
`static InetAddress`
`getInetAddress(String key, InetAddress def)`
Retrieve an `InetAddress`.
`static InetAddress[]`
`getInetAddressArray(String key, String delim, InetAddress[] def)`
Retrieve an array of `InetAddress` created from a property value containting a `delim` separated list of hostnames and/or ipaddresses.
`static int`
`getInt(String key)`
Retrieve an `int`.
`static int`
`getInt(String key, int def)`
Retrieve an `int`.
`static InetAddress`
`getLocalHost()`
`static long`
`getLong(String key, long def)`
Retrieve a `long`.
`static String`
`getProperty(String key)`
Retrieve a `String`.
`static String`
`getProperty(String key, String def)`
Retrieve a `String`.
`static void`
`list(PrintStream out)`
List the properties in the `Code`.
`static void`
`load(InputStream in)`
Load the `Config` with properties from the stream `in` from a `Properties` file.
`static void`
`registerSmbURLHandler()`
This static method registers the SMB URL protocol handler which is required to use SMB URLs with the `java.net.URL` class.
`static void`
`setProperties(Properties prp)`
Set the default properties of the static Properties used by `Config`.
`static Object`
`setProperty(String key, String value)`
Add a property.
`static void`
`store(OutputStream out, String header)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### socketCount

public static int socketCount

### DEFAULT_OEM_ENCODING

public static String DEFAULT_OEM_ENCODING

## Method Details

### registerSmbURLHandler

public static void registerSmbURLHandler()
This static method registers the SMB URL protocol handler which is required to use SMB URLs with the `java.net.URL` class. If this method is not called before attempting to create an SMB URL with the URL class the following exception will occur:

>      Exception MalformedURLException: unknown protocol: smb
>          at java.net.URL.<init>(URL.java:480)
>          at java.net.URL.<init>(URL.java:376)
>          at java.net.URL.<init>(URL.java:330)
>          at jcifs.smb.SmbFile.<init>(SmbFile.java:355)
>          ...

### setProperties

public static void setProperties(Properties prp)
Set the default properties of the static Properties used by `Config`. This permits a different Properties object/file to be used as the source of properties for use by the jCIFS library. The Properties must be set before jCIFS classes are accessed as most jCIFS classes load properties statically once. Using this method will also override properties loaded using the `-Djcifs.properties=` commandline parameter.

### load

public static void load(InputStream in) throws IOException
Load the `Config` with properties from the stream `in` from a `Properties` file.

Throws:
  `IOException`

### store

public static void store(OutputStream out, String header) throws IOException

Throws:
  `IOException`

### list

public static void list(PrintStream out) throws IOException
List the properties in the `Code`.

Throws:
  `IOException`

### setProperty

public static Object setProperty(String key, String value)
Add a property.

### get

public static Object get(String key)
Retrieve a property as an `Object`.

### getProperty

public static String getProperty(String key, String def)
Retrieve a `String`. If the key cannot be found, the provided `def` default parameter will be returned.

### getProperty

public static String getProperty(String key)
Retrieve a `String`. If the property is not found, `null` is returned.

### getInt

public static int getInt(String key, int def)
Retrieve an `int`. If the key does not exist or cannot be converted to an `int`, the provided default argument will be returned.

### getInt

public static int getInt(String key)
Retrieve an `int`. If the property is not found, `-1` is returned.

### getLong

public static long getLong(String key, long def)
Retrieve a `long`. If the key does not exist or cannot be converted to a `long`, the provided default argument will be returned.

### getInetAddress

public static InetAddress getInetAddress(String key, InetAddress def)
Retrieve an `InetAddress`. If the address is not an IP address and cannot be resolved `null` will be returned.

### getLocalHost

public static InetAddress getLocalHost()

### getBoolean

public static boolean getBoolean(String key, boolean def)
Retrieve a boolean value. If the property is not found, the value of `def` is returned.

### getInetAddressArray

public static InetAddress[] getInetAddressArray(String key, String delim, InetAddress[] def)
Retrieve an array of `InetAddress` created from a property value containting a `delim` separated list of hostnames and/or ipaddresses.